#include <msp430.h>
#include "dr_sdcard.h"
#include "dr_tft.h"
#include "dr_usbmsc.h"
#include <string.h>
#include <stdio.h>

#define FBUF_SIZE 320*3
uint8_t fbuf[FBUF_SIZE];

typedef struct tagBITMAPFILEHEADER
{
  WORD bfType; // λͼļͣΪBM(1-2ֽڣ
  DWORD bfSize; // λͼļĴСֽΪλ3-6ֽڣ
  WORD bfReserved1; // λͼļ֣Ϊ0(7-8ֽڣ
  WORD bfReserved2; // λͼļ֣Ϊ0(9-10ֽڣ
  DWORD bfOffBits; // λͼݵʼλãλͼ11-14ֽڣ
                   // ļͷƫʾֽΪλ
} BITMAPFILEHEADER;

typedef struct tagBITMAPINFOHEADER{
  DWORD biSize; // ṹռֽ15-18ֽڣ
  LONG biWidth; // λͼĿȣΪλ19-22ֽڣ
  LONG biHeight; // λͼĸ߶ȣΪλ23-26ֽڣ
  WORD biPlanes; // Ŀ豸ļ𣬱Ϊ1(27-28ֽڣ
  WORD biBitCount;// ÿλ1˫ɫ29-30ֽڣ
                  // 4(16ɫ8(256ɫ24ɫ֮һ
  DWORD biCompression; // λͼѹͣ 0ѹ31-34ֽڣ
                       // 1(BI_RLE8ѹͣ2(BI_RLE4ѹ֮ͣһ
  DWORD biSizeImage; // λͼĴСֽΪλ35-38ֽڣ
  LONG biXPelsPerMeter; // λͼˮƽֱʣÿ39-42ֽڣ
  LONG biYPelsPerMeter; // λͼֱֱʣÿ43-46ֽ)
  DWORD biClrUsed;// λͼʵʹõɫеɫ47-50ֽڣ
  DWORD biClrImportant;// λͼʾҪɫ51-54ֽڣ
} BITMAPINFOHEADER;

BITMAPFILEHEADER _bmpFileHeader;
BITMAPINFOHEADER _bmpInfo;

int bmp_CheckHeader(BITMAPFILEHEADER *h)
{
  if(h->bfType != 19778) //'BM'
    return 0;
  if(h->bfReserved1 != 0 || h->bfReserved2 != 0)
    return 0;
  return 1;
}

int bmp_CheckFormat(BITMAPINFOHEADER *i)
{
  if(i->biSize != 40)
    return 0;
  if(i->biBitCount != 24) //֧24λͼĸʽ
    return 0;
  if(i->biCompression != 0) //֧ѹ
    return 0;
  if(i->biWidth > 320) //̫
    return 0;
  if(i->biHeight > 240) //̫
    return 0;
  return 1;
}

int bmp_DisplayBmpFile(char *filename)
{
  FRESULT rc;
  FIL fil; /* File object */
  uint16_t size;

  rc = f_open(&fil, filename, FA_READ); //ļ
  rc = f_read(&fil, &_bmpFileHeader, sizeof(_bmpFileHeader), &size); //ȡļͷ
  if (rc || size != sizeof(_bmpFileHeader)) /* Error or end of file */
  {
    f_close(&fil); //رļ
    return 0;
  }
  if (!bmp_CheckHeader(&_bmpFileHeader)) //ļͷʽ
  {
    f_close(&fil); //رļ
    return 0;
  }

  rc = f_read(&fil, &_bmpInfo, sizeof(_bmpInfo), &size); //ȡļϢ
  if (rc || size != sizeof(_bmpInfo)) /* Error or end of file */
  {
    f_close(&fil); //رļ
    return 0;
  }
  if (!bmp_CheckFormat(&_bmpInfo)) //ļʽ
  {
    f_close(&fil); //رļ
    return 0;
  }

  uint32_t row_length = _bmpInfo.biWidth * 3; //ÿ3
  if(row_length & 0x3) //4ʱ
  {
    row_length |= 0x03;
    row_length += 1;
  }

  int r, rcnt = _bmpInfo.biHeight;
  if(rcnt > 0) //תλͼ˳µ
    r = rcnt - 1;
  else
  { //˳ϵ£ټ
    r = 0;
    rcnt = -rcnt;
  }

  while(1)
  {
    rc = f_read(&fil, &fbuf, row_length, &size); //ȡһе
    if (rc || size != row_length) /* Error or end of file */
    {
      f_close(&fil); //رļ
      return 0;
    }
    etft_DisplayImage(fbuf, 0, r, _bmpInfo.biWidth, 1);
    if(_bmpInfo.biHeight > 0) //תλͼ
      r--;
    else
      r++;
    rcnt--;
    if(rcnt == 0)
      break;
  }

  f_close(&fil); //رļ
  return 1;
}

