#include <msp430.h>
#include <stdint.h>
#include "dr_step_motor.h"
#include "dr_lcdseg.h"

int adc0;

void initClock()
{
  while(BAKCTL & LOCKIO) // Unlock XT1 pins for operation
    BAKCTL &= ~(LOCKIO);
  UCSCTL6 &= ~XT1OFF; //XT1
  P7SEL |= BIT2 + BIT3; //XT2Źѡ
  UCSCTL6 &= ~XT2OFF; //XT2
  while (SFRIFG1 & OFIFG) { //ȴXT1XT2DCOȶ
    UCSCTL7 &= ~(DCOFFG+XT1LFOFFG+XT2OFFG);
    SFRIFG1 &= ~OFIFG;
  }

  UCSCTL4 = SELA__XT1CLK + SELS__XT2CLK + SELM__XT2CLK; //DCOܷ

  UCSCTL1 = DCORSEL_5; //6000kHz~23.7MHz
  UCSCTL2 = 16000000 / (4000000 / 16); //XT2ƵʽϸߣƵΪ׼ɻøߵľ
  UCSCTL3 = SELREF__XT2CLK + FLLREFDIV__16; //XT216ƵΪ׼
  while (SFRIFG1 & OFIFG) { //ȴXT1XT2DCOȶ
    UCSCTL7 &= ~(DCOFFG+XT1LFOFFG+XT2OFFG);
    SFRIFG1 &= ~OFIFG;
  }
  UCSCTL5 = DIVA__1 + DIVS__1 + DIVM__1; //趨CLKķƵ
  UCSCTL4 = SELA__XT1CLK + SELS__XT2CLK + SELM__DCOCLK; //趨CLKʱԴ
}

void initADC()
{
  //ڴʼ
  adc0 = 0;
  //IO趨
  P7SEL |= BIT7; //֤ûģź
  //TB0趨
  TB0CTL = TBSSEL__SMCLK + MC__UP; // SMCLK, up-mode
  TB0CCR0 = 4000000 / 6400 - 1; // 4MHz -> 6.4kHz
  TB0CCTL0 = OUTMOD_4; //ʵֻ3.2kHz
  //ADC趨
  ADC12CTL1 = ADC12SHS_2 + ADC12SHP + ADC12CONSEQ_1; //TB0.0ͨ
  ADC12MCTL0 = ADC12SREF_0 + ADC12INCH_15 + ADC12EOS; //3.3VԴοA15ͨĩβ
  ADC12CTL0 = ADC12MSC + ADC12ON + ADC12SHT0_8 + ADC12ENC; //زADC12ONMEM0~MEM7ʹ256ڲENC
  ADC12IE = BIT0; //ж(ͨ0תɺж)
}

#pragma vector=ADC12_VECTOR
__interrupt void ADC12ISR (void)
{
  adc0 = ADC12MEM0;
  ADC12CTL0 &= ~ADC12ENC;
  ADC12CTL0 |= ADC12ENC;
}

int main( void )
{
  // Stop watchdog timer to prevent time out reset
  WDTCTL = WDTPW + WDTHOLD;

  _DINT();
  initClock();
  initADC();
  initStepMotor();
  initLcdSeg();
  _EINT();

  StepMotor_SetEnable(1);

  //IOʼ
  P4REN |= 0x1F; //ʹܰ˿ϵ
  P4OUT |= 0x1F; //״̬

  uint8_t last_btn = 0x1F, cur_btn, temp;
  while(1)
  {
    cur_btn = P4IN & 0x1F;
    temp = (cur_btn ^ last_btn) & last_btn; //ҳİ
    last_btn = cur_btn;

    int16_t rpm = ((int32_t)adc0) * 600L / 4096L;
    LCDSEG_DisplayNumber(rpm, 0);
    StepMotor_SetRPM(rpm);

    if(temp & BIT3) //S4
      StepMotor_AddStep(360000);
    else if(temp & BIT1) //S6
      StepMotor_AddStep(-360000);
    else if(temp & BIT2) //S5
      StepMotor_ClearStep();
    else if(temp & BIT0) //S7
      StepMotor_AddStep(-1);
    else if(temp & BIT4) //S3
      StepMotor_AddStep(1);

    __delay_cycles(1600000);
  }
}
