#ifndef __DR_USB_HID_H_
#define __DR_USB_HID_H_

#define KEY_MOD_None                0x00
#define KEY_MOD_LeftControl         0x01
#define KEY_MOD_LeftShift           0x02
#define KEY_MOD_LeftAlt             0x04
#define KEY_MOD_LeftGUI             0x08
#define KEY_MOD_RightControl        0x10
#define KEY_MOD_RightShift          0x20
#define KEY_MOD_RightAlt            0x40
#define KEY_MOD_RightGUI            0x80

#define KEY_CODE_None                0x00
#define KEY_CODE_Reserved            0x00
#define KEY_CODE_ErrorRollOver       0x01
#define KEY_CODE_POSTFail            0x02
#define KEY_CODE_ErrorUndefined      0x03
#define KEY_CODE_A                   0x04
#define KEY_CODE_B                   0x05
#define KEY_CODE_C                   0x06
#define KEY_CODE_D                   0x07
#define KEY_CODE_E                   0x08
#define KEY_CODE_F                   0x09
#define KEY_CODE_G                   0x0A
#define KEY_CODE_H                   0x0B
#define KEY_CODE_I                   0x0C
#define KEY_CODE_J                   0x0D
#define KEY_CODE_K                   0x0E
#define KEY_CODE_L                   0x0F
#define KEY_CODE_M                   0x10
#define KEY_CODE_N                   0x11
#define KEY_CODE_O                   0x12
#define KEY_CODE_P                   0x13
#define KEY_CODE_Q                   0x14
#define KEY_CODE_R                   0x15
#define KEY_CODE_S                   0x16
#define KEY_CODE_T                   0x17
#define KEY_CODE_U                   0x18
#define KEY_CODE_V                   0x19
#define KEY_CODE_W                   0x1A
#define KEY_CODE_X                   0x1B
#define KEY_CODE_Y                   0x1C
#define KEY_CODE_Z                   0x1D
#define KEY_CODE_1                   0x1E
#define KEY_CODE_2                   0x1F
#define KEY_CODE_3                   0x20
#define KEY_CODE_4                   0x21
#define KEY_CODE_5                   0x22
#define KEY_CODE_6                   0x23
#define KEY_CODE_7                   0x24
#define KEY_CODE_8                   0x25
#define KEY_CODE_9                   0x26
#define KEY_CODE_0                   0x27
#define KEY_CODE_Enter               0x28
#define KEY_CODE_Escape              0x29
#define KEY_CODE_Backspace           0x2A
#define KEY_CODE_Tab                 0x2B
#define KEY_CODE_Spacebar            0x2C
#define KEY_CODE_Minus               0x2D
#define KEY_CODE_Equal               0x2E
#define KEY_CODE_LeftBracket         0x2F
#define KEY_CODE_RightBracket        0x30
#define KEY_CODE_Backslash           0x31
#define KEY_CODE_VerticalBar         0x32
#define KEY_CODE_Semicolon           0x33
#define KEY_CODE_Apostrophe          0x34
#define KEY_CODE_Tilde               0x35
#define KEY_CODE_Comma               0x36
#define KEY_CODE_Period              0x37
#define KEY_CODE_Slash               0x38
#define KEY_CODE_CapsLock            0x39
#define KEY_CODE_F1                  0x3A
#define KEY_CODE_F2                  0x3B
#define KEY_CODE_F3                  0x3C
#define KEY_CODE_F4                  0x3D
#define KEY_CODE_F5                  0x3E
#define KEY_CODE_F6                  0x3F
#define KEY_CODE_F7                  0x40
#define KEY_CODE_F8                  0x41
#define KEY_CODE_F9                  0x42
#define KEY_CODE_F10                 0x43
#define KEY_CODE_F11                 0x44
#define KEY_CODE_F12                 0x45
#define KEY_CODE_PrintScreen         0x46
#define KEY_CODE_ScrollLock          0x47
#define KEY_CODE_Pause               0x48
#define KEY_CODE_Insert              0x49
#define KEY_CODE_Home                0x4A
#define KEY_CODE_PageUp              0x4B
#define KEY_CODE_DeleteForward       0x4C
#define KEY_CODE_End                 0x4D
#define KEY_CODE_PageDown            0x4E
#define KEY_CODE_RightArrow          0x4F
#define KEY_CODE_LeftArrow           0x50
#define KEY_CODE_DownArrow           0x51
#define KEY_CODE_UpArrow             0x52
#define KEY_CODE_KeypadNumlock       0x53
#define KEY_CODE_KeypadSlash         0x54
#define KEY_CODE_KeypadAsterisk      0x55
#define KEY_CODE_KeypadMinus         0x56
#define KEY_CODE_KeypadPlus          0x57
#define KEY_CODE_KeypadEnter         0x58
#define KEY_CODE_Keypad1             0x59
#define KEY_CODE_Keypad2             0x5A
#define KEY_CODE_Keypad3             0x5B
#define KEY_CODE_Keypad4             0x5C
#define KEY_CODE_Keypad5             0x5D
#define KEY_CODE_Keypad6             0x5E
#define KEY_CODE_Keypad7             0x5F
#define KEY_CODE_Keypad8             0x60
#define KEY_CODE_Keypad9             0x61
#define KEY_CODE_Keypad0             0x62
#define KEY_CODE_KeypadPeriod        0x63
#define KEY_CODE_NonUsBackslash      0x64
#define KEY_CODE_WindowsKey          0x65
#define KEY_CODE_Power               0x66
#define KEY_CODE_KeypadEqual         0x67
#define KEY_CODE_F13                 0x68
#define KEY_CODE_F14                 0x69
#define KEY_CODE_F15                 0x6A
#define KEY_CODE_F16                 0x6B
#define KEY_CODE_F17                 0x6C
#define KEY_CODE_F18                 0x6D
#define KEY_CODE_F19                 0x6E
#define KEY_CODE_F20                 0x6F
#define KEY_CODE_F21                 0x70
#define KEY_CODE_F22                 0x71
#define KEY_CODE_F23                 0x72
#define KEY_CODE_F24                 0x73
#define KEY_CODE_Execute             0x74
#define KEY_CODE_Help                0x75
#define KEY_CODE_Menu                0x76
#define KEY_CODE_Select              0x77
#define KEY_CODE_Stop                0x78
#define KEY_CODE_Again               0x79
#define KEY_CODE_Undo                0x7A
#define KEY_CODE_Cut                 0x7B
#define KEY_CODE_Copy                0x7C
#define KEY_CODE_Paste               0x7D
#define KEY_CODE_Find                0x7E
#define KEY_CODE_Mute                0x7F
#define KEY_CODE_VolumeUp            0x80
#define KEY_CODE_VolumneDown         0x81
#define KEY_CODE_LockingCapsLock     0x82
#define KEY_CODE_LockingNumLock      0x83
#define KEY_CODE_LockingScrollLock   0x84
#define KEY_CODE_KeypadComma         0x85
#define KEY_CODE_AS400KeypadEqual    0x86
#define KEY_CODE_International1      0x87
#define KEY_CODE_International2      0x88
#define KEY_CODE_International3      0x89
#define KEY_CODE_International4      0x8A
#define KEY_CODE_International5      0x8B
#define KEY_CODE_International6      0x8C
#define KEY_CODE_International7      0x8D
#define KEY_CODE_International8      0x8E
#define KEY_CODE_International9      0x8F
#define KEY_CODE_Lang1               0x90
#define KEY_CODE_Lang2               0x91
#define KEY_CODE_Lang3               0x92
#define KEY_CODE_Lang4               0x93
#define KEY_CODE_Lang5               0x94
#define KEY_CODE_Lang6               0x95
#define KEY_CODE_Lang7               0x96
#define KEY_CODE_Lang8               0x97
#define KEY_CODE_Lang9               0x98
#define KEY_CODE_AlternateErase      0x99
#define KEY_CODE_SysReq              0x9A
#define KEY_CODE_Cancel              0x9B
#define KEY_CODE_Clear               0x9C
#define KEY_CODE_Prior               0x9D
#define KEY_CODE_Return              0x9E
#define KEY_CODE_Separator           0x9F
#define KEY_CODE_Out                 0xA0
#define KEY_CODE_Oper                0xA1
#define KEY_CODE_ClearAgain          0xA2
#define KEY_CODE_CrSelProps          0xA3
#define KEY_CODE_ExSel               0xA4
#define KEY_CODE_LeftControl         0xE0
#define KEY_CODE_LeftShift           0xE1
#define KEY_CODE_LeftAlt             0xE2
#define KEY_CODE_LeftGUI             0xE3
#define KEY_CODE_RightControl        0xE4
#define KEY_CODE_RightShift          0xE5
#define KEY_CODE_RightAlt            0xE6
#define KEY_CODE_RightGUI            0xE7

#endif
